﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Reflection;

namespace Builder
{
    public class MyNode : TreeNode
    {
        private MyData data;
        private Form form;

        public MyNode (Form f)
        {
            form = f;
            data = new MyData (this);
        }

        public void connect ()
        {
            Control obj = this.Tag as Control;
            if (obj != null)
            {
                form.DataBindings.Add ("Text", obj, "Text");
                data.DataBindings.Add ("Text", obj, "Text");
                data.DataBindings.Add ("BackColor", obj, "BackColor");
            }
            if (obj is INotifyPropertyChanged)
            {
                INotifyPropertyChanged p = obj as INotifyPropertyChanged;
                p.PropertyChanged += OnPropertyChange;
            }
        }
        private void OnPropertyChange (object sender, PropertyChangedEventArgs e)
        {
            object obj = this.Tag;
            this.Text = e.PropertyName;
            if (e.PropertyName == "BackColor")
            {
                Type type = obj.GetType ();
                PropertyInfo prop = type.GetProperty ("BackColor");
                Color color = (Color) prop.GetValue (obj);
                this.BackColor = color;
            }
        }
    }
}
